using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using System.Drawing.Drawing2D;

namespace Comrade.nrControls
{
	/// <summary>
	/// Line ̊Tv̐łB
	/// </summary>
	public class Line : System.Windows.Forms.Control
	{
		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Line()
		{
			// ̌ĂяóAWindows.Forms tH[ fUCiŕKvłB
			InitializeComponent();

			// TODO: InitComponent ĂяǒɏǉĂB

		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if( components != null )
					components.Dispose();
			}
			base.Dispose( disposing );
		}

		#region R|[lg fUCiŐꂽR[h 
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e 
		/// R[hnGfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
			components = new System.ComponentModel.Container();
		}
		#endregion

		private PointF startPoint = new PointF(0, 0);
		private PointF endPoint = new PointF(0, 0);
		private PointF midPoint = new PointF(0, 0);
		private bool landscape = true;
		private float sin = 0;
		private float cos = 0;
		private float HperW = 0; // tan
		private float WperH = 0; // 1/tan
		private float lineLength = 0;
		private float mulX = 0;
		private float mulY = 0;
		private float startAdjust = 0;
		private float endAdjust = 0;
		private float diagonalAngle = 0;
		private float mulAngle = 0;

		private float lineWidth = 1;
		public float LineWidth
		{
			get
			{
				return lineWidth;
			}
			set
			{
				lineWidth = value;
				SetRegion();
				Invalidate();
			}
		}

		private DashStyle lineStyle = DashStyle.Solid;
		public DashStyle LineStyle
		{
			get
			{
				return lineStyle;
			}
			set
			{
				lineStyle = value;
				SetRegion();
				Invalidate();
			}
		}

		private Direction direction = Direction.LowerRight;
		public Direction Direction
		{
			get
			{
				return direction;
			}
			set
			{
				direction = value;
				SetRegion();
				Invalidate();
			}
		}

		private LineCap startCap = LineCap.Flat;
		public LineCap StartCap
		{
			get
			{
				return startCap;
			}
			set
			{
				startCap = value;
				SetRegion();
				Invalidate();
			}
		}

		private LineCap endCap = LineCap.Flat;
		public LineCap EndCap
		{
			get
			{
				return endCap;
			}
			set
			{
				endCap = value;
				SetRegion();
				Invalidate();
			}
		}

		private DashCap dashCap = DashCap.Flat;
		public DashCap DashCap
		{
			get
			{
				return dashCap;
			}
			set
			{
				dashCap = value;
				SetRegion();
				Invalidate();
			}
		}

		private void SetRegion()
		{
			SetPoint();
			AdjustPoint(true);
			AdjustPoint(false);
			Region region = new Region(GetLinePath());
			region.Union(GetCapPath(true));
			region.Union(GetCapPath(false));
			Region = region;
		}

		private void SetPoint()
		{
			midPoint.X = Width / 2f;
			midPoint.Y = Height / 2f;
			landscape = Width >= Height;
			lineLength = (float)Math.Sqrt(Height * Height + Width * Width);
			sin = Height/lineLength;
			cos = Width/lineLength;
			HperW = (float)Height/(float)Width; // tan
			WperH = (float)Width/(float)Height; // 1/tan
			diagonalAngle = (float)Math.Tanh(HperW);
			mulAngle = 0;
			switch (Direction)
			{
			case Direction.Up:
				startPoint.X = midPoint.X;
				startPoint.Y = Height;
				endPoint.X = midPoint.X;
				endPoint.Y = 0;
				break;
			case Direction.Down:
				startPoint.X = midPoint.X;
				startPoint.Y = 0;
				endPoint.X = midPoint.X;
				endPoint.Y = Height;
				break;
			case Direction.Left:
				startPoint.X = Width;
				startPoint.Y = midPoint.Y;
				endPoint.X = 0;
				endPoint.Y = midPoint.Y;
				break;
			case Direction.Right:
				startPoint.X = 0;
				startPoint.Y = midPoint.Y;
				endPoint.X = Width;
				endPoint.Y = midPoint.Y;
				break;
			case Direction.UpperLeft:
				startPoint.X = Width;
				startPoint.Y = Height;
				endPoint.X = 0;
				endPoint.Y = 0;
				mulAngle = 1;
				break;
			case Direction.UpperRight:
				startPoint.X = 0;
				startPoint.Y = Height;
				endPoint.X = Width;
				endPoint.Y = 0;
				mulAngle = -1;
				break;
			case Direction.LowerLeft:
				startPoint.X = Width;
				startPoint.Y = 0;
				endPoint.X = 0;
				endPoint.Y = Height;
				mulAngle = -1;
				break;
			case Direction.LowerRight:
				startPoint.X = 0;
				startPoint.Y = 0;
				endPoint.X = Width;
				endPoint.Y = Height;
				mulAngle = 1;
				break;
			}
		}

		private void AdjustPoint(bool start)
		{
			switch (Direction)
			{
			case Direction.Up:
				mulX = 0;
				mulY = 1;
				break;
			case Direction.Down:
				mulX = 0;
				mulY = -1;
				break;
			case Direction.Left:
				mulX = 1;
				mulY = 0;
				break;
			case Direction.Right:
				mulX = -1;
				mulY = 0;
				break;
			case Direction.UpperLeft:
				if (landscape)
				{
					mulX = WperH;
					mulY = 1;
				}
				else
				{
					mulX = 1;
					mulY = HperW;
				}
				break;
			case Direction.UpperRight:
				if (landscape)
				{
					mulX = -WperH;
					mulY = 1;
				}
				else
				{
					mulX = -1;
					mulY = HperW;
				}
				break;
			case Direction.LowerLeft:
				if (landscape)
				{
					mulX = WperH;
					mulY = -1;
				}
				else
				{
					mulX = 1;
					mulY = -HperW;
				}
				break;
			case Direction.LowerRight:
				if (landscape)
				{
					mulX = -WperH;
					mulY = -1;
				}
				else
				{
					mulX = -1;
					mulY = -HperW;
				}
				break;
			}
			LineCap cap = EndCap;
			PointF point = endPoint;
			float mulx = mulX;
			float muly = mulY;
			if (start)
			{
				cap = StartCap;
				point = startPoint;
				mulx = -mulX;
				muly = -mulY;
			}
			float adjust = 0;
			switch (cap)
			{
			case LineCap.Square:
				adjust = LineWidth / 2;
				break;
			case LineCap.Round:
				adjust = LineWidth / 2;
				break;
			case LineCap.Triangle:
				adjust = LineWidth / 2;
				break;
			case LineCap.SquareAnchor:
				adjust = LineWidth;
				break;
			case LineCap.RoundAnchor:
				adjust = LineWidth;
				break;
			case LineCap.DiamondAnchor:
				adjust = LineWidth;
				break;
			}
			point.X += adjust * mulx;
			point.Y += adjust * muly;
			if (cap == LineCap.ArrowAnchor)
				adjust = LineWidth * (float)Math.Sqrt(3);
			if (start)
			{
				startPoint = point;
				startAdjust = adjust;
			}
			else
			{
				endPoint = point;
				endAdjust = adjust;
			}
		}

		private GraphicsPath GetLinePath()
		{
			GraphicsPath path = new GraphicsPath();
			PointF sp = startPoint;
			PointF ep = endPoint;
			float ratio = (float)(1 / Math.Sqrt(mulX * mulX + mulY * mulY));
			float mulx = mulX * ratio;
			float muly = mulY * ratio;
			if (StartCap == LineCap.ArrowAnchor)
			{
				sp.X -= startAdjust * mulx;
				sp.Y -= startAdjust * muly;
			}
			if (EndCap == LineCap.ArrowAnchor)
			{
				ep.X += endAdjust * mulx;
				ep.Y += endAdjust * muly;
			}
			switch (Direction)
			{
			case Direction.Up:
				lineLength = sp.Y - ep.Y;
				path.AddRectangle(new RectangleF(ep.X - LineWidth / 2, ep.Y, LineWidth, lineLength));
				break;
			case Direction.Down:
				lineLength = ep.Y - sp.Y;
				path.AddRectangle(new RectangleF(sp.X - LineWidth / 2, sp.Y, LineWidth, lineLength));
				break;
			case Direction.Left:
				lineLength = sp.X - ep.X;
				path.AddRectangle(new RectangleF(ep.X, ep.Y - LineWidth / 2, lineLength, LineWidth));
				break;
			case Direction.Right:
				lineLength = ep.X - sp.X;
				path.AddRectangle(new RectangleF(sp.X, sp.Y - LineWidth / 2, lineLength, LineWidth));
				break;
			default:
				float r = lineWidth / 2;
				PointF[] points = { new PointF(0, 1), new PointF(-1, 0), new PointF(0, -1), new PointF(1, 0) };
				if (Direction == Direction.UpperLeft || Direction == Direction.LowerLeft)
				{
					PointF point = ep;
					ep = sp;
					sp = point;
				}
				if (Direction == Direction.UpperRight || Direction == Direction.LowerLeft)
				{
					points[0].X = ep.X - r * sin;
					points[0].Y = ep.Y - r * cos;
					points[1].X = sp.X - r * sin;
					points[1].Y = sp.Y - r * cos;
					points[2].X = sp.X + r * sin;
					points[2].Y = sp.Y + r * cos;
					points[3].X = ep.X + r * sin;
					points[3].Y = ep.Y + r * cos;
				}
				else
				{
					points[0].X = sp.X + r * sin;
					points[0].Y = sp.Y - r * cos;
					points[1].X = sp.X - r * sin;
					points[1].Y = sp.Y + r * cos;
					points[2].X = ep.X - r * sin;
					points[2].Y = ep.Y + r * cos;
					points[3].X = ep.X + r * sin;
					points[3].Y = ep.Y - r * cos;
				}
				path.AddPolygon(points);
				break;
			}
			return path;
		}

		private GraphicsPath GetCapPath(bool start)
		{
			GraphicsPath path = new GraphicsPath();
			LineCap cap = EndCap;
			PointF point = endPoint;
			float adjust = endAdjust;
			float mulx = mulX;
			float muly = mulY;
			if (start)
			{
				cap = StartCap;
				point = startPoint;
				adjust = startAdjust;
				mulx = -mulX;
				muly = -mulY;
			}
			float margin = 1;
			if (mulAngle != 0 && cap != LineCap.Round && cap != LineCap.RoundAnchor)
				margin = 1.15f;
			adjust *= margin;
			float angle = diagonalAngle * margin;
			switch (cap)
			{
			case LineCap.Square:
				goto case LineCap.SquareAnchor;
			case LineCap.Round:
				goto case LineCap.RoundAnchor;
			case LineCap.Triangle:
				goto case LineCap.DiamondAnchor;
			case LineCap.SquareAnchor:
				RectangleF rectangle = new RectangleF(point.X - adjust, point.Y - adjust, adjust * 2, adjust * 2);
				if (mulAngle != 0)
					path.AddPolygon(Rotate(point, angle, rectangle));
				else
					path.AddRectangle(rectangle);
				break;
			case LineCap.RoundAnchor:
				path.AddEllipse(point.X - adjust, point.Y - adjust, adjust * 2, adjust * 2);
				break;
			case LineCap.DiamondAnchor:
				PointF[] diamond = 
				{
					new PointF(point.X, point.Y - adjust),
					new PointF(point.X - adjust, point.Y),
					new PointF(point.X, point.Y + adjust),
					new PointF(point.X + adjust, point.Y)
				};
				if (mulAngle != 0)
					diamond = Rotate(point, angle, diamond);
				path.AddPolygon(diamond);
				break;
			case LineCap.ArrowAnchor:
				float ratio = (float)(1 / Math.Sqrt(mulX * mulX + mulY * mulY));
				point.X += adjust * mulx * ratio;
				point.Y += adjust * muly * ratio;
				if ((start && Direction == Direction.Down) || (!start && Direction == Direction.Up))
				{
					PointF[] triangle =
					{
						new PointF(point.X - adjust / 2, point.Y),
						new PointF(point.X + adjust / 2, point.Y),
						new PointF(point.X, point.Y - adjust)
					};
					path.AddPolygon(triangle);
				}
				else if  ((start && Direction == Direction.Up) || (!start && Direction == Direction.Down))
				{
					PointF[] triangle =
					{
						new PointF(point.X - adjust / 2, point.Y),
						new PointF(point.X + adjust / 2, point.Y),
						new PointF(point.X, point.Y + adjust)
					};
					path.AddPolygon(triangle);
				}
				else if  ((start && Direction == Direction.Right) || (!start && Direction == Direction.Left)
					   || (start && Direction == Direction.UpperRight) || (!start && Direction == Direction.LowerLeft)
					   || (start && Direction == Direction.LowerRight) || (!start && Direction == Direction.UpperLeft))
				{
					PointF[] triangle =
					{
						new PointF(point.X, point.Y - adjust / 2),
						new PointF(point.X, point.Y + adjust / 2),
						new PointF(point.X - adjust, point.Y)
					};
					if (mulAngle != 0)
						triangle = Rotate(point, angle, triangle);
					path.AddPolygon(triangle);
				}
				else
				{
					PointF[] triangle =
					{
						new PointF(point.X, point.Y - adjust / 2),
						new PointF(point.X, point.Y + adjust / 2),
						new PointF(point.X + adjust, point.Y)
					};
					if (mulAngle != 0)
						triangle = Rotate(point, angle, triangle);
					path.AddPolygon(triangle);
				}
				break;
			}
			return path;
		}

		private PointF[] Rotate(PointF origin, float angle, RectangleF rc)
		{
			PointF[] points =
			{
				new PointF(rc.X, rc.Y),
				new PointF(rc.X, rc.Y + rc.Height),
				new PointF(rc.X + rc.Width, rc.Y + rc.Height),
				new PointF(rc.X + rc.Width, rc.Y)
			};
			return Rotate(origin, angle, points);
		}

		private PointF[] Rotate(PointF origin, float angle, PointF[] points)
		{
			for (int i = 0; i < points.Length; i++)
				points[i] = Rotate(origin, angle, points[i].X, points[i].Y);
			return points;
		}

		private PointF Rotate(PointF origin, float angle, float x, float y)
		{
			PointF point = new PointF(0, 0);
			float rotateAngle = angle * mulAngle;
			x -= origin.X;
			y -= origin.Y;
			point.X = (float)(x * Math.Cos(rotateAngle) - y * Math.Sin(rotateAngle) + origin.X);
			point.Y = (float)(x * Math.Sin(rotateAngle) + y * Math.Cos(rotateAngle) + origin.Y);
			return point;
		}

		protected override void OnSizeChanged(EventArgs e)
		{
			// TODO:  Line.OnSizeChanged ǉ܂B
			SetRegion();
			Invalidate();
			base.OnSizeChanged (e);
		}
	
		protected override void OnPaint(PaintEventArgs e)
		{
			// TODO:  Line.OnPaint ǉ܂B
			Pen pen = new Pen(ForeColor, LineWidth);
			pen.SetLineCap(StartCap, EndCap, DashCap);
			pen.DashStyle = LineStyle;
			e.Graphics.DrawLine(pen, startPoint, endPoint);
			//base.OnPaint (e);
		}
	}
}
