using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using System.Drawing.Drawing2D;

namespace Comrade.nrControls
{
	/// <summary>
	/// UserControl1 ̊Tv̐łB
	/// </summary>
	public class nrButton : System.Windows.Forms.Button
	{
		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		private System.ComponentModel.Container components = null;

		public nrButton()
		{
			// ̌ĂяóAWindows.Forms tH[ fUCiŕKvłB
			InitializeComponent();

			// TODO: InitComponent ĂяǒɏǉĂB
			nrd.ClientRectangle = ClientRectangle;
			nrd.shape = shape;
			nrd.direction = direction;
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if( components != null )
					components.Dispose();
			}
			base.Dispose( disposing );
		}

		#region R|[lg fUCiŐꂽR[h 
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e 
		/// R[hnGfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
			components = new System.ComponentModel.Container();
		}
		#endregion

		private bool pressed = false;
		private bool mouseHover = false;
		private nrDrawing nrd = new nrDrawing();
		private RectangleF textRect = new RectangleF(0, 0, 0, 0);

		private Shape shape = Shape.Pentagon;
		public Shape Shape
		{
			get
			{
				return shape;
			}
			set
			{
				shape = value;
				nrd.shape = shape;
				SetRegion();
				Invalidate();
			}
		}

		private Direction direction = Direction.Right;
		public Direction Direction
		{
			get
			{
				return direction;
			}
			set
			{
				direction = value;
				nrd.direction = direction;
				SetRegion();
				Invalidate();
			}
		}

		private void SetRegion()
		{
			if (FlatStyle == FlatStyle.System || shape == Shape.Rectangle)
				Region = new Region(ClientRectangle);
			else
			{
				nrd.ClientRectangle = ClientRectangle;
				GraphicsPath path = new GraphicsPath();
				nrd.SetPath(path);
				Region = new Region(path);
			}
		}

		private void SetTextRect(Graphics graphics)
		{
			SizeF size = graphics.MeasureString(Text, Font);

			float left = ClientRectangle.Left + 5;
			switch (TextAlign)
			{
			case ContentAlignment.BottomCenter:
				left = ClientRectangle.Left + (ClientRectangle.Width - size.Width) / 2;
				break;
			case ContentAlignment.MiddleCenter:
				goto case ContentAlignment.BottomCenter;
			case ContentAlignment.TopCenter:
				goto case ContentAlignment.BottomCenter;
			case ContentAlignment.BottomRight:
				left = ClientRectangle.Right - size.Width - 5;
				break;
			case ContentAlignment.MiddleRight:
				goto case ContentAlignment.BottomRight;
			case ContentAlignment.TopRight:
				goto case ContentAlignment.BottomRight;
			}

			float top = ClientRectangle.Top + 5;
			switch (TextAlign)
			{
			case ContentAlignment.MiddleCenter:
				top = ClientRectangle.Top + (ClientRectangle.Height - size.Height) / 2;
				break;
			case ContentAlignment.MiddleLeft:
				goto case ContentAlignment.MiddleCenter;
			case ContentAlignment.MiddleRight:
				goto case ContentAlignment.MiddleCenter;
			case ContentAlignment.BottomCenter:
				top = ClientRectangle.Bottom - size.Height - 5;
				break;
			case ContentAlignment.BottomLeft:
				goto case ContentAlignment.BottomCenter;
			case ContentAlignment.BottomRight:
				goto case ContentAlignment.BottomCenter;
			}

			textRect = new RectangleF(left, top, size.Width, size.Height);
		}

		private void DrawEllipse(Graphics graphics)
		{
			graphics.FillEllipse(new SolidBrush(BackColor), ClientRectangle);
			Rectangle innerRect = Rectangle.Inflate(ClientRectangle, -1, -1);

			if (FlatStyle == FlatStyle.Flat)
			{
				Brush brush = pressed ? nrDrawing.lightestBrush : (mouseHover ? nrDrawing.darkerBrush : null);
				if (brush != null)
					graphics.FillEllipse(brush, ClientRectangle);
				graphics.DrawEllipse(nrDrawing.thickDarkestPen, innerRect);
			}
			else if (FlatStyle == FlatStyle.Popup)
			{
				if (pressed || !mouseHover)
					graphics.DrawEllipse(nrDrawing.thickDarkerPen, innerRect);
				else if (mouseHover)
					nrd.Draw3DEllipse(graphics, true);
				else
					nrd.Draw3DEllipse(graphics, false);
				if (pressed)
					textRect.Offset(1, 1);
			}
			else
			{
				if (pressed)
				{
					graphics.DrawEllipse(nrDrawing.thickDarkestPen, innerRect);
					textRect.Offset(1, 1);
				}
				else
					nrd.Draw3DEllipse(graphics, true);
			}
		}
	
		private void DrawPolygon(Graphics graphics)
		{
			Point[] points = null;
			switch (shape)
			{
			case Shape.Diamond:
				points = nrd.diamondPoints;
				break;
			case Shape.Triangle:
				points = nrd.trianglePoints;
				break;
			case Shape.Pentagon:
				points = nrd.pentagonPoints;
				break;
			case Shape.Arrow:
				points = nrd.arrowPoints;
				break;
			}

			graphics.FillPolygon(new SolidBrush(BackColor), points);

			if (FlatStyle == FlatStyle.Flat)
			{
				Brush brush = pressed ? nrDrawing.lightestBrush : (mouseHover ? nrDrawing.darkerBrush : null);
				if (brush != null)
					graphics.FillPolygon(brush, points);
				graphics.DrawPolygon(nrDrawing.thickDarkestPen, points);
			}
			else if (FlatStyle == FlatStyle.Popup)
			{
				if (pressed || !mouseHover)
					graphics.DrawPolygon(nrDrawing.thickDarkerPen, points);
				else if (mouseHover)
					nrd.Draw3DPolygon(graphics, true);
				else
					nrd.Draw3DPolygon(graphics, false);
				if (pressed)
					textRect.Offset(1, 1);
			}
			else
			{
				if (pressed)
				{
					graphics.DrawPolygon(nrDrawing.thickDarkestPen, points);
					textRect.Offset(1, 1);
				}
				else
					nrd.Draw3DPolygon(graphics, true);
			}
		}
	
		protected override void OnCreateControl()
		{
			// TODO:  nrButton.OnCreateControl ǉ܂B
			SetRegion();
			base.OnCreateControl ();
		}
	
		protected override void OnSizeChanged(EventArgs e)
		{
			// TODO:  nrButton.OnSizeChanged ǉ܂B
			SetRegion();
			base.OnSizeChanged (e);
		}
	
		protected override void OnKeyDown(KeyEventArgs kevent)
		{
			// TODO:  nrButton.OnKeyDown ǉ܂B
			if (kevent.KeyData == Keys.Space)
				pressed = true;
			base.OnKeyDown (kevent);
		}
	
		protected override void OnKeyUp(KeyEventArgs kevent)
		{
			// TODO:  nrButton.OnKeyUp ǉ܂B
			if (kevent.KeyCode == Keys.Space)
				pressed = false;
			base.OnKeyUp (kevent);
		}
	
		protected override void OnMouseDown(MouseEventArgs mevent)
		{
			// TODO:  nrButton.OnMouseDown ǉ܂B
			if (mevent.Button == MouseButtons.Left)
				pressed = true;
			base.OnMouseDown (mevent);
		}
	
		protected override void OnMouseUp(MouseEventArgs mevent)
		{
			// TODO:  nrButton.OnMouseUp ǉ܂B
			if (mevent.Button == MouseButtons.Left)
				pressed = false;
			base.OnMouseUp (mevent);
		}
	
		protected override void OnMouseEnter(EventArgs eventargs)
		{
			// TODO:  nrButton.OnMouseEnter ǉ܂B
			mouseHover = true;
			base.OnMouseEnter (eventargs);
		}
	
		protected override void OnMouseLeave(EventArgs eventargs)
		{
			// TODO:  nrButton.OnMouseLeave ǉ܂B
			mouseHover = false;
			base.OnMouseLeave (eventargs);
		}
	
		protected override void OnPaint(PaintEventArgs pevent)
		{
			// TODO:  nrButton.OnPaint ǉ܂B
			if (FlatStyle == FlatStyle.System || shape == Shape.Rectangle)
			{
				base.OnPaint (pevent);
				return;
			}

			SetTextRect(pevent.Graphics);

			if (shape == Shape.Ellipse)
				DrawEllipse(pevent.Graphics);
			else
				DrawPolygon(pevent.Graphics);

			pevent.Graphics.DrawString(Text, Font, new SolidBrush(ForeColor), textRect);
			// base.OnPaint (pevent);
		}
	}
}
